# change_title.py
# Author: Kevin Ollivier
# License: wxWidgets License
# Description: Changes the old blue gradient titles to the new wx site format

import sys, os, string
import re

root_dir = os.getcwd()

old_title_re = """<table width=100% border=0 cellpadding=3 cellspacing=0>
<tr>
<td bgcolor="\#004080" align=left height=24 background="images/bluetitlegradient.gif">
<font size=\+1 face="Arial, Lucida Sans, Helvetica" color="\#FFFFFF">
<b>([^(</b>)]*)</b>
</font>
</td>
</tr>
</table>
"""

new_title = '<div class="page_heading"><img src="%s/images/blocks2.gif" alt="About" width="30" height="20" /> %s</div>'

def updateDir(dirname):
    """
    This function recursively walks through the subdirectories and
    updates any HTML files it finds.
    """
    for item in os.listdir(dirname):
        fullpath = os.path.join(dirname, item)
        
        if os.path.isfile(fullpath):
            extension = os.path.splitext(fullpath)[1]
            if string.find(extension, "htm") != -1:
                updateFile(fullpath)
        
        elif os.path.isdir(fullpath):
            updateDir(fullpath)

def updateFile(filename):
    if 1:
        title = ""
        # Read in the page data we want to keep
        html = open(filename).read()
        title_regex = re.compile(old_title_re, re.IGNORECASE)
        results = title_regex.search(html)
        if results:
            print "result found!"
            title = results.group(1)
        
        if title != "":
            print "Updating " + filename
        
        relative_path = string.replace(os.path.dirname(filename), root_dir, "")[1:]
        subdirs = len(relative_path.split(os.sep))
        reldir = ".."
        for num in range(1, subdirs-1):
            reldir = reldir + "/.."
        html = title_regex.sub(new_title % (reldir, title), html)
        
        newfile = open(filename, "w")
        newfile.write(html)
        newfile.close()
    else: #except:
        if newfile:
            newfile.close()
        print "Error with " + filename
        

updateDir(root_dir)